% Main : Test with ZBC(t,T,S,X), S = T+2y
clear
clc
clf

disp('Loading market data...');
tic;
LoadMktData;
toc;

Strikes_KRW = zeros(15,1);
for kkk = 1:15
    Strikes_KRW(kkk) = getDF(TyrsZC_KRW, RatesZC_KRW, TyrsZC_KRW(kkk)+2) % P(0,S), S=T+2y: ATM Strike
end

ZCBO_Formula = zeros(15,1);
ZCBO_FDM = zeros(15,1);

RMSEs_omega = zeros(15,1);
RMSEs = zeros(15,1);
e2s_omega = zeros(15,1);
e2s = zeros(15,1);

for kkk=5:10 % For each quoted bucket in zero curve

    T = TdysZC_KRW(kkk)/365;
    S = T + 2;
    Strike_KRW = Strikes_KRW(kkk);
    
    disp(' '); disp('Setting grid...');
    tic;
    SetGrid;
    toc;

    disp(' '); disp('Setting model...');
    tic;
    SetSDE;
    toc;

    disp(' '); disp('Setting finite difference method...');
    tic;
    SetFDM;
    toc;

    disp(' '); disp('Solving finite difference method...');
    tic;
    SolveFDM_1d;
    toc;

    disp(' '); disp('Calculating Analytic values...');
    tic;
    CalcAnalValues_1d;
    toc;
    
    disp(' '); disp('Calculating Errors...');
    tic;
    CalcErrors_1d;
    toc;
    
end
