% Main : Test with ZBC(t,T,S,X), S = T+2y
clear
clc
clf

disp('Loading market data...');
tic;
LoadMktData;
toc;

Strikes_KRW = zeros(15,1);
Strikes_USD = zeros(15,1);
for kkk = 1:15
    Strikes_KRW(kkk) = getDF(TyrsZC_KRW, RatesZC_KRW, TyrsZC_KRW(kkk)+2); % P1(0,S1), S1=T+2y: ATM Strike
    Strikes_USD(kkk) = getDF(TyrsZC_USD, RatesZC_USD, TyrsZC_USD(kkk)+2); % P2(0,S2), S2=T+2y: ATM Strike
end

ZBDC2d_Formula = zeros(15,1);
ZBDC2d_FDM = zeros(15,1);

RMSEs_omega = zeros(15,1);
RMSEs = zeros(15,1);
e2s_omega = zeros(15,1);
e2s = zeros(15,1);

for kkk=5:10 % For each quoted bucket in zero curve

    kkk
    T = TdysZC_KRW(kkk)/365;
    S1 = T + 2;
    S2 = S1;
    
   Strike_KRW = Strikes_KRW(kkk);
   Strike_USD = Strikes_USD(kkk);
%    Strike = 0.8;
    
    disp(' '); disp('Setting grid...');
    tic;
    SetGrid;
    toc;

    disp(' '); disp('Setting model...');
    tic;
    SetSDE;
    toc;

    disp(' '); disp('Setting finite difference method...');
    tic;
    SetFDM;
    toc;

    disp(' '); disp('Solving finite difference method...');
    tic;
    SolveFDM_2d;
    toc;

    disp(' '); disp('Calculating Analytic values...');
    tic;
    CalcAnalValues_2d;
    toc;
    
    disp(' '); disp('Calculating Errors...');
    tic;
    CalcErrors_2d;
    toc;
    
end
