% Set Coefficients for Solving FDM
% Need to modify code so that updating proceeds only at nedded time

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%% 1.Regarding A*Ux=gx : Uy => Ux (U(k+1) => tmpU) %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Coefficients
px = zeros(Nt,Nx+1);    % px(:,1), px(:,Nx+1) are not used.
qx = zeros(Nt,1);
for k=1:Nt
    for i=2:Nx
        px(k,i) = a*x(i)*ht(k)/(2*hx);
    end
    qx(k) = 0.5*(xi_mid(k)^2)*(ht(k)/hx^2);
end

% Source Term
sx = zeros(Nt,1);
wx = zeros(Nt,Nx+1);
for k=1:Nt
    sx(k) = 0.5*rho*xi(k+1)*psi(k+1)*(ht(k)/(4*hx*hy));
    for i=2:Nx
        wx(k,i) = 0.5*(x(i) + alpha(k+1))*ht(k);
    end
end

% Elements of Coefficient Matrix
dx = zeros(Nt,Nx+1);    % dx(:,1), dx(:,Nx+1) are not used.
ex = zeros(Nt,1);
fx = zeros(Nt,Nx+1);    % fx(:,1), fx(:,Nx+1) are not used.
for k=1:Nt
    for i=2:Nx
       dx(k,i) = -px(k,i)-qx(k);
       fx(k,i) = px(k,i)-qx(k);
    end
    ex(k) = 1+2*qx(k);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%% 2.Regarding B*Uy=gy : Ux => Uy (tmpU => U(k)) %%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Coefficients
py = zeros(Nt,Ny+1);    % py(:,1), py(:,Ny+1) are not used.
qy = zeros(Nt,1);
for k=1:Nt
    for j=2:Ny
        py(k,j) = (b*y(j)-c*psi(k)*sig(k))*(ht(k)/(2*hy));
    end
    qy(k) = 0.5*(psi(k)^2)*(ht(k)/hy^2);
end

% Source Term
sy = zeros(Nt,1);
wy = zeros(Nt,Ny+1);    % wy(:,1), wy(:,Ny+1) are not used.
for k=1:Nt
    sy(k) = 0.5*rho*xi_mid(k)*psi_mid(k)*(ht(k)/(4*hx*hy));
    for i=2:Nx  % iӿ 
       wy(k,i) = 0.5*(x(i)+alpha_mid(k))*ht(k);
    end
end

% Elements of Coefficient Matrix
dy = zeros(Nt,Ny+1);    % dy(:,1), dy(:,Ny+1) are not used.
ey = zeros(Nt,1);
fy = zeros(Nt,Ny+1);    % fy(:,1), fy(:,Ny+1) are not used.
for k=1:Nt
    for j=2:Ny
       dy(k,j) = -py(k,j)-qy(k);
       fy(k,j) = py(k,j)-qy(k);
    end
    ey(k) = 1+2*qy(k);
end
