% Grid Setting

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 1.Time Grid %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Time Grid set-up considering maturity of product
MatDay = TdysZC_KRW(kkk);    % kkk is the index for market quoted buckets; 
htDay = 2;  % # of days equivalent to ht. 4 seems to be suitable.
Tdys = [0:htDay:MatDay]';    % This could not contain all maturities
Tdys(end) = MatDay;
Tyrs = Tdys/365;  % Tyrs(1)=0,
Nt = length(Tyrs) - 1;  % so that Tyrs(Nt+1)=Maturity

% Time Grid set-up considering calculation of interest rates
MatDayFull = MatDay + TdysZC_KRW(1) + 2*htDay;    % enougly..!
tmpTdysFull = [MatDay+htDay:htDay:MatDayFull]';
TdysFull = [Tdys;tmpTdysFull];
TyrsFull = TdysFull/365;
NtFull = length(TyrsFull) - 1;  % TyrsFull(Nt+1)=TyrsFull(end)

ht = TyrsFull(2:NtFull+1) - TyrsFull(1:NtFull);     % ht(k)=t(k+1)-t(k), k=1, 2, ..., Nt

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 2.Space Grid %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
MatYr = MatDayFull/365;

% x-axis
% xmax = 5*HWVols_KRW(end)*sqrt((1-exp(-2*a*MatYr))/(2*a));
xmax = 0.20;    % xmax = +4(x)
xmin = -xmax;   % xmin = -4
Nx = 300;   % Must be even
hx = (xmax-xmin)/Nx;
x = [xmin:hx:xmax]';    % x(1)=xmin, x(Nx+1)=xmax

% y-axis
% ymax = 5*HWVols_USD(end)*sqrt((1-exp(-2*b*MatYr))/(2*b));
ymax = xmax;    % ymax = +4(y)
ymin = -ymax;   % ymin = -4(y)
Ny = Nx;   % Must be even
hy = (ymax-ymin)/Ny;
y = [ymin:hy:ymax]';    % y(1)=ymin, y(Ny+1)=ymax
