function y0 = interpol_Const(x, y, x0)

% Piecewise Constant interpolation (Left-Continuous)
% x : x(1) < x(2) < ... < x(NumDatas)
% y : y(1) < y(2) < ... < y(NumDatas)

NumDatas = length(x);

if x0 <= x(1)
    y0 = y(1);
elseif x0 >= x(NumDatas)
    y0 = y(NumDatas);
else
    for i=2:NumDatas
        if x0 <= x(i)
            y0 = y(i);
            break;
        end
    end
end

