function y0 = interpol_Lin(x, y, x0)

% Piecewise Linear interpolation
% x : x(1) < x(2) < ... < x(NumDatas)
% y : y(1) < y(2) < ... < y(NumDatas)

NumDatas = length(x);

if x0 <= x(1)
    y0 = y(1);
elseif x0 >= x(NumDatas)
    y0 = y(NumDatas);
else
    for i=2:NumDatas
        if x0 < x(i)
            y0 = y(i-1) + (y(i)-y(i-1))/(x(i)-x(i-1))*(x0-x(i-1));
            break;
        end
    end
end
